'FFSubmenu=Tools
'FFName=Dialoganpassung

'(c) Harald Maeckler, Dsseldorf 2017
' ***********************************************************************
' Dialoganpassung.vbs (Skript fr FixFoto)
' ***********************************************************************

' Version 1.00 vom 10.03.2017	- Betaversion
' ***********************************************************************

'**Start Encode**

Option Explicit

Dim X,Y,dQuelle,dZiel,msgH
const RegSchluessel = "FF_Dialoganpassung"

'Objekte
Dim objFS,WshShell
Set objFS = CreateObject("Scripting.FileSystemObject")
Set WshShell = CreateObject("WScript.Shell")

'------------------------------------------------------------------------
call Hilfetext
call main
' ***********************************************************************
'Faktoreintrag in Dialogtext
' ***********************************************************************
Sub main

'** Start Dialog Dialoganpassung **
FF_AddDialog "Dialoganpassung",84,59
FF_AddControl "Dialoganpassung","Faktoren-Benennung","GROUP",5,5,74,33
FF_AddControl "Dialoganpassung","X-Achse","STATIC",10,14,22,10
FF_AddControl "Dialoganpassung","X_Name","SLEDIT",40,14,33,10
FF_SetControlStyle "Dialoganpassung","X_Name",1
FF_AddControl "Dialoganpassung","Y-Achse","STATIC",10,25,22,10
FF_AddControl "Dialoganpassung","Y_Name","SLEDIT",40,25,33,10
FF_SetControlStyle "Dialoganpassung","Y_Name",1
FF_AddControl "Dialoganpassung","?","BUTTON",6,43,11,11
FF_AddControl "Dialoganpassung","Messen","BUTTON",23,43,25,11
FF_AddControl "Dialoganpassung","Start","BUTTON",53,43,25,11
'** End Dialog Dialoganpassung **

call RegistryLesen

do
	Select Case FF_ShowDialog ("Dialoganpassung")
	Case "?"
		WshShell.Popup msgH,,"Erluterungen",vbInformation
	Case "Messen"
		Dim X1,Y1
		call Werte_Auslesen
		call GetDlgUnits(X1,Y1)
		msgbox X & " = " & X1 & " / " & Y & " = " & Y1,vbInformation,"Faktoren"
		exit do
	Case "Start"
		call Werte_Auslesen
		dQuelle = FF_TextFromClipboard
		if len(dQuelle) > 0 then
			if instr(dQuelle,"FF_AddDialog") > 0 then
				call Anpassung
			else
				msgbox "Im Text fehlt 'FF_AddDialog'!",vbExclamation,"Abbruch"
			end if
		else
			msgbox "Kein Text in der Zwischenablage!",vbExclamation,"Abbruch"
		end if
		exit do
	Case "CANCEL"
		exit do
	End Select
loop

call RegistrySchreiben
FF_CloseDialog ("Dialoganpassung")

End Sub
'------------------------------------------------------------------------
Sub HilfeText

msgH = "" &_
"Das Skript dient dazu in einem vorhandenen Dialogtext zu berck-" & vbNewLine &_
"sichtigende Faktoren fr Breite (X) und Hhe (Y) einzutragen." & vbNewLine & vbNewLine &_
"- Dialogtext in die Zwischenablage kopieren" & vbNewLine &_
"- Skript Dialoganpassung aufrufen" & vbNewLine &_
"- Nach 'Start' befindet sich der Dialogtext mit den Faktoren in" & vbNewLine &_
"   in der Zwischenablage" & vbNewLine & vbNewLine &_
"Copyright Harald Maeckler"

End Sub
'------------------------------------------------------------------------
Sub Werte_Auslesen

X = FF_GetControl("Dialoganpassung","X_Name")
Y = FF_GetControl("Dialoganpassung","Y_Name")

End Sub
'------------------------------------------------------------------------
Sub RegistryLesen
'Schlsselname = HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\ & RegSchluessel

'### Werte auslesen

X = FF_GetProfile(RegSchluessel,"X")
if len(X) = 0 then X = "FX"

Y = FF_GetProfile(RegSchluessel,"Y")
if len(Y) = 0 then Y = "FY"

'### Werte eintragen

FF_SetControl "Dialoganpassung","X_Name",X
FF_SetControl "Dialoganpassung","Y_Name",Y

End Sub
'------------------------------------------------------------------------
Sub RegistrySchreiben
'Schlsselname = HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\ & RegSchluessel

call Werte_Auslesen

'Werte schreiben
FF_WriteProfile RegSchluessel,"X",X
FF_WriteProfile RegSchluessel,"Y",Y

End Sub
'------------------------------------------------------------------------
Sub Anpassung
Dim dArray,dElement,zArray

X = " *" & X
Y = " *" & Y
'FF_AddDialog "Dialoganpassung",84,59
'FF_AddControl "Dialoganpassung","Faktoren-Benennung","GROUP",5,5,74,33

dArray = split(dQuelle,vbNewLine)
for each dElement in dArray
	if instr(dElement,"FF_AddDialog") > 0 then
		zArray = split(dElement,",")
		dZiel = zArray(0) & "," & zArray(1) & X & "," & zArray(2) & Y & vbNewLine
	elseif instr(dElement,"FF_AddControl") > 0 then
		zArray = split(dElement,",")
		dZiel = dZiel & zArray(0) & "," & zArray(1) & ","  & zArray(2) & "," &_
						zArray(3) & X & "," & zArray(4) & Y & "," &_
						zArray(5) & X & "," & zArray(6) & Y & vbNewLine
	elseif instr(dElement,"FF_SetControlStyle") > 0 then
		dZiel = dZiel & dElement & vbNewLine
	end if
next

FF_TextToClipboard dZiel
msgbox "Der ergnzte Dialogtext befindet sich jetzt in der Zwischenablage.",vbInformation,"Schlussmeldung"

End Sub
' ***********************************************************************
'Ermittlung des Faktors fr Dialogunits
' ***********************************************************************
Sub GetDlgUnits(dlgXFaktor,dlgYFaktor)
Dim lUnits,lxScale,lyScale
 
lUnits = CLng(FF_GetDialogBaseUnits)
lxScale = lUnits And 65535
lyScale = lUnits \ 65536
dlgXFaktor = lxScale / 8
dlgYFaktor = lyScale / 16
 
End Sub
' ***********************************************************************
